#include <cstdio>
#include <cstring>

	const int MAX = 1<<9;
	int G[MAX][MAX];
	int A[MAX][MAX];
	int num[MAX][MAX];
	int dist[MAX];
	int ans[MAX];
	int prev[MAX];

	bool used[MAX];

	int n;
	const int inf = 10000000;

void input () {

	int m, cnt = 1;
	scanf ("%d%d", &n, &m);

	//printf ("%d %d\n", n, m);

	for (; m; m--) {
	
		int u, v, c;
		scanf ("%d%d%d", &u, &v, &c);
		u--; v--;
		G[u][v] = G[v][u] = c;
		num[u][v] = num[v][u] = cnt++;
	}

	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
			scanf ("%d", &A[i][j]);

}

void prim() {

	for (int i = 0; i < n; ++i) {

		dist[i] = inf;
		G[i][i] = 0;
	}

	dist[0] = 0;
	prev[0] = 0;

	for (int i = 0; i < n; ++i) {
	
		int minDist = inf, v = -1;

		for (int j = 0; j < n; ++j)
			if (dist[j] < minDist && !used[j]) {
			
				minDist = dist[j];
				v = j;
				
			}

		used[v] = 1;
		ans[i] = num[v][prev[v]];

		for (int j = 0; j < n; ++j)
			if (!used[j] && dist[j] > G[v][j] && G[v][j] != -1) {
			
				dist[j] = G[v][j];
				prev[j] = v;
			}
	}
}

void initialize() {

	memset (G, -1, sizeof(G));
	memset (A, 0, sizeof(A));
	memset (used, 0, sizeof(used));
}

void print () {

	for (int i = 1; i < n; ++i)
		printf("%d\n", ans[i]);
}
int main()
{
	freopen("graph.in", "r", stdin);
	freopen("graph.out", "w", stdout);

	initialize();
	input();
	prim();
	print();

	return 0;
}

